"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var GoogleActionsModule_1, _a;
Object.defineProperty(exports, "__esModule", { value: true });
exports.GoogleActionsModule = void 0;
require("reflect-metadata");
const constant_1 = require("../constant");
const google_actions_controller_1 = require("./google-actions.controller");
const google_action_provider_1 = require("./google-action.provider");
const discovery_1 = require("@nestjs-plus/discovery");
const common_1 = require("@nestjs/common");
const core_1 = require("../core");
const __1 = require("..");
let GoogleActionsModule = GoogleActionsModule_1 = class GoogleActionsModule {
    constructor(discoveryService, handlerContainer) {
        this.discoveryService = discoveryService;
        this.handlerContainer = handlerContainer;
    }
    static forRoot(webHookConfig) {
        webHookConfig = Object.assign({ basePath: 'web-hooks', postPath: 'google-actions' }, webHookConfig);
        return {
            module: GoogleActionsModule_1,
            providers: [google_action_provider_1.GoogleActionsProvider, core_1.HandlerContainer],
            controllers: [google_actions_controller_1.GoogleActionsController.forRoot(webHookConfig)],
        };
    }
    onModuleInit() {
        return __awaiter(this, void 0, void 0, function* () {
            const providersMethodAndMetaForIntent = yield this.discoveryService.providerMethodsWithMetaAtKey(constant_1.GOOGLE_ACTION_INTENT);
            const providersMethodAndMetaForAction = yield this.discoveryService.providerMethodsWithMetaAtKey(constant_1.GOOGLE_ACTION);
            const providersMethodAndMeta = [
                ...providersMethodAndMetaForIntent,
                ...providersMethodAndMetaForAction,
            ];
            for (const providerMethodAndMeta of providersMethodAndMeta) {
                this.handlerContainer.register(providerMethodAndMeta.meta, providerMethodAndMeta.discoveredMethod.parentClass.instance, providerMethodAndMeta.discoveredMethod.methodName);
            }
        });
    }
    configure(consumer) {
        return consumer.apply(__1.GoogleActionsAuthorizationMiddleware).forRoutes(google_actions_controller_1.GoogleActionsController);
    }
};
GoogleActionsModule = GoogleActionsModule_1 = __decorate([
    common_1.Module({
        imports: [discovery_1.DiscoveryModule],
        providers: [google_action_provider_1.GoogleActionsProvider, core_1.HandlerContainer],
        controllers: [google_actions_controller_1.GoogleActionsController],
    }),
    __metadata("design:paramtypes", [typeof (_a = typeof discovery_1.DiscoveryService !== "undefined" && discovery_1.DiscoveryService) === "function" ? _a : Object, core_1.HandlerContainer])
], GoogleActionsModule);
exports.GoogleActionsModule = GoogleActionsModule;
